{-# LANGUAGE FlexibleInstances,
             UndecidableInstances,
             ScopedTypeVariables
 #-}

module AOP.Semantics.Default where
import AOP.Internal.AOPMonad
import AOP.Internal.Typeable1Monad
import AOP.Internal.Aspect
import AOP.Internal.AOTType
import AOP.Internal.Pointcut

{- | Default semantics for aspect deployment/undeployment -}

instance (Typeable1Monad m, Monad (AOT m)) => MonadDeploy m where
      deployInEnv   asp aenv = return (EAspect asp:aenv)
      undeployInEnv asp@(Aspect (pc::PC (AOT m) t1) adv hnd) aenv =
                    return (deleteAsp (EAspect asp) aenv)